Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ulibmtp;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Procedure Button1Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private

  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

Uses ctypes;

Procedure Nop();
Begin

End;

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
{$IFNDEF LINUX}
  BAM, das geht nur mit Linux...
{$ENDIF}
  LIBMTP_Init();
End;

Var
  aFolder: String;

Procedure dump_fileinfo(file_: PLIBMTP_file_t);
Begin
  //  form1.memo1.lines.add(format('File ID: %u', [file_^.item_id]));
  If assigned(file_^.filename) Then
    form1.memo1.lines.add(format('Filename: %s', [aFolder + file_^.filename]));

  // This is sort of special...
//  If (file_^.filesize = high(uint32_t) - 1) Then Begin
//    form1.memo1.lines.add('   None.(abstract file_, size = -1)');
//  End
//  Else Begin
    //    #ifdef __WIN32__
//    printf(" File_ size %llu(0 x%016I64X)bytes\n", file_ - > filesize, file_ - > filesize);
    //    #Else
//    form1.memo1.lines.add(format('   File size %llu(0 x%016llX)bytes', [file_^.filesize, file_^.filesize]));
    //    #Endif
//  End;
//  form1.memo1.lines.add(format(' Parent ID: %u', [file_^.parent_id]));
//  form1.memo1.lines.add(format(' Storage ID: 0x%08X', [file_^.storage_id]));
//  form1.memo1.lines.add(format(' Filetype: %s', [LIBMTP_Get_Filetype_Description(file_^.filetype)]));
End;


Procedure dump_files(device: PLIBMTP_mtpdevice_t; storageid: uint32_t; leaf: cint);
Var
  files: PLIBMTP_file_t;
  File_, tmp: PLIBMTP_file_t;
  oFolder: String;
Begin
  (* Get file listing. *)
  files := LIBMTP_Get_Files_And_Folders(device, storageid, leaf);
  If Not assigned(files) Then Begin
    LIBMTP_Dump_Errorstack(device);
    LIBMTP_Clear_Errorstack(device);
  End
  Else Begin
    //    LIBMTP_file_t *file_, *tmp;
    file_ := files;
    While assigned(file_) Do Begin
      (* Please don't print these *)
      If (file_^.filetype = LIBMTP_FILETYPE_FOLDER) Then Begin
        oFolder := aFolder;
        aFolder := aFolder + File_^.filename + PathDelim;
        dump_files(device, storageid, file_^.item_id);
        aFolder := oFolder;
      End
      Else Begin
        dump_fileinfo(file_);
      End;
      tmp := file_;
      file_ := file_^.next;
      LIBMTP_destroy_file_t(tmp);
    End;
  End;
End;

// Entnommen aus : https://github.com/libmtp/libmtp/blob/master/examples/files.c

Procedure TForm1.Button1Click(Sender: TObject);
Var
  err: LIBMTP_error_number_t;
  i, numrawdevices: integer;
  rawdevices: PLIBMTP_raw_device_t;
  device: PLIBMTP_mtpdevice_t;
  friendlyname: Pchar;
  storage: ^LIBMTP_devicestorage_t;
Begin

  Memo1.Clear;
  Memo1.lines.BeginUpdate;
  //  rawdevices := nil;
  //  numrawdevices := 0;

  (* Verbindung aufnehmen *)
  err := LIBMTP_Detect_Raw_Devices(rawdevices, numrawdevices);
  Case err Of
    LIBMTP_ERROR_NO_DEVICE_ATTACHED: Begin
        ShowMessage('mtp - files: No Devices have been found');
        exit;
      End;
    LIBMTP_ERROR_CONNECTING: Begin
        ShowMessage('mtp-files: There has been an error connecting.');
        exit;
      End;
    LIBMTP_ERROR_MEMORY_ALLOCATION: Begin
        ShowMessage('mtp-files: Memory Allocation Error.');
        exit;
      End;
    LIBMTP_ERROR_NONE: Begin
        nop(); // Nix, es hat ja geklappt ;)
      End;
  Else Begin
      // LIBMTP_ERROR_GENERAL:
      (* Unknown general errors - This should never execute *)
      ShowMessage('mtp - files: Unknown error, please report this to the libmtp developers');
      exit;
    End;
  End;
  (* infos Auslesen *)

  (* iterate through connected MTP devices *)
  For i := 0 To numrawdevices - 1 Do Begin
    device := LIBMTP_Open_Raw_Device_Uncached(rawdevices);
    If Not assigned(device) Then Begin
      ShowMessage(format('Unable to open raw device %d, maybe it is already mounted -> unmount and retry.', [i]));
      continue;
    End;
    // Echo the friendly name so we know which device we are working with
    friendlyname := LIBMTP_Get_Friendlyname(device);
    If Not assigned(friendlyname) Then Begin
      memo1.lines.add('Listing File Information on Device ' + rawdevices^.device_entry.vendor + ' ' + rawdevices^.device_entry.product);
    End
    Else Begin
      memo1.lines.add('Listing File Information on Device with name: ' + friendlyname);
    End;

    LIBMTP_Dump_Errorstack(device);
    LIBMTP_Clear_Errorstack(device);

    // Loop over storages
    storage := device^.storage;
    While assigned(storage) Do Begin
      aFolder := storage^.StorageDescription + PathDelim;
      dump_files(device, storage^.id, LIBMTP_FILES_AND_FOLDERS_ROOT);
      storage := storage^.next;
    End;
    LIBMTP_Release_Device(device);

    inc(rawdevices);
  End;
  Memo1.lines.EndUpdate;
  Memo1.SelStart := length(Memo1.Text);
End;

End.

